﻿using System;
using Android.App;
using Android.Content;
using Android.Widget;
using Android.OS;
using System.ComponentModel;
using System.Threading;
using Android.Graphics;
using Android.Views;
using System.Threading.Tasks;
using NoxService.NWS;
using NoxKeys;
using Android.Runtime;
using Android.Content.Res;
using WalletLibrary;
using Android.Net.Wifi;
using Android.Net;
using WalletLibrary.Core;
using Android.Preferences;

namespace BitfiWallet
{

  [Activity(Name = "my.MainActivityN", MainLauncher = true, Label = "", Theme = "@style/FullscreenTheme", LaunchMode = Android.Content.PM.LaunchMode.SingleTop)]
  class MainActivityB : Activity
  {
    protected override void OnCreate(Bundle savedInstanceState)
    {

      base.OnCreate(null);
      NoxMainActivity.Value = this;
      SetContentView(Resource.Layout.Main);
      Window.AddFlags(Android.Views.WindowManagerFlags.Fullscreen | WindowManagerFlags.LayoutNoLimits | WindowManagerFlags.LayoutInOverscan);

      NoxMainActivity.LoadVTypes();
      LoadClickViews();

      if (NoxTManager.noxDevice.IsErrorKey())
      {
        FindViewById<TextView>(Resource.Id.txtDEVICEID).Text = "|  ERROR";
      }

      tbbWifi = FindViewById<TextView>(Resource.Id.txtNoWifi); w1 = FindViewById<ImageView>(Resource.Id.imageViewW1);
      w2 = FindViewById<ImageView>(Resource.Id.imageViewW2);

    }

    public override void OnBackPressed()
    {
      base.OnBackPressed();
      OverridePendingTransition(0, 0);
    }
    protected override void OnResume()
    {
      base.OnResume();

      rescl = false;
    }
    protected override void OnStart()
    {

      base.OnStart();

      try
      {
        NoxMainActivity.LoadBatStatus(NoxMainActivity.GetBatVal());
      }
      catch { }

      tbbWifi.Text = "checking wifi...";

      NoxMainActivity.Start();

    }

    bool keep; bool rescl; bool acresult;
    TextView tbbWifi; ImageView w1; ImageView w2;
    protected override void OnActivityResult(int requestCode, [GeneratedEnum] Result resultCode, Intent data)
    {
      base.OnActivityResult(requestCode, resultCode, data);

      try
      {

        if (data.HasExtra("connected"))
        {
          string[] resp = data.GetStringArrayExtra("connected");
          NetTask(resp[0], resp[1]);
        }

        if (data.HasExtra("timeout"))
        {
          acresult = true;
          NoxMainActivity.Stop();
          Finish();
        }

        if (data.HasExtra("request"))
        {
          acresult = true;
          NoxMainActivity.Stop();
          string[] req = data.GetStringArrayExtra("request");
          RequestPrompt(req[0], req[1], req[2]);
        }

        data.Extras.Clear();
      }
      catch { }

    }
    void NetTask(string ConnectionStatus, string _nowifi = "true")
    {
      try
      {
        tbbWifi.Text = ConnectionStatus;

        bool nowifi = Convert.ToBoolean(_nowifi);

        if (nowifi)
        {
          w1.Visibility = ViewStates.Gone; w2.Visibility = ViewStates.Visible;
        }
        else
        {
          w1.Visibility = ViewStates.Visible; w2.Visibility = ViewStates.Gone;
        }
      }
      catch { }
    }

    protected override void OnStop()
    {

      NoxMainActivity.Stop();

      if (!keep)
      {
        if (!this.IsFinishing)
        {
          Finish();
        }
      }

      keep = false;

      base.OnStop();

    }
    private void ShowInitMsg()
    {
      AlertDialog.Builder builder = new AlertDialog.Builder(this)
      .SetTitle("").SetMessage("Error starting wallet.").SetCancelable(false).SetPositiveButton("ok", (EventHandler<DialogClickEventArgs>)null);
      var alert = builder.Create();
      alert.Show();
      var okBtn = alert.GetButton((int)DialogButtonType.Positive);

      okBtn.Click += (asender, args) =>
      {
        alert.Dismiss();
        Finish();
      };
    }
    private void StartSAct(string action, string task, string display_token = null)
    {

      var nxact = new Intent(this, typeof(SecretActivity));
      nxact.PutExtra("action", action);
      nxact.PutExtra("task", task);

      if (display_token != null)
      {
        nxact.PutExtra("display_token", display_token);
      }

      StartActivity(nxact);

    }
    private void RequestPrompt(string action, string SMSToken, string display_token)
    {

      try
      {
        var cntx = GetActionMsg(action, display_token);
        if (cntx == null) return;

        string msg = cntx[0];
        string title = "";


        if (action == "signin" || action == "register2fa" || action == "authorize2fa")
        {
          title = display_token;
        }


        AlertDialog.Builder builder = new AlertDialog.Builder(this).SetTitle(title).SetMessage(msg).SetCancelable(false).SetNegativeButton("NO", (EventHandler<DialogClickEventArgs>)null)
        .SetPositiveButton("Yes, Continue", (EventHandler<DialogClickEventArgs>)null);
        AlertDialog alert = builder.Create();

        NoxMainActivity.AddTime();
        alert.Show();
        TextView msgTxt = (TextView)alert.FindViewById(Android.Resource.Id.Message);
        msgTxt.TextSize = 20;
        msgTxt.SetTypeface(null, TypefaceStyle.Bold);
        var okBtn = alert.GetButton((int)DialogButtonType.Positive);
        var nokBtn = alert.GetButton((int)DialogButtonType.Negative);
        nokBtn.Click += (asender, args) =>
        {
          alert.Dismiss();
          Finish();
        };


        okBtn.Click += (asender, args) =>
        {
          StartSAct(action, SMSToken, display_token);
          alert.Dismiss();
        };
      }
      catch { }
    }

    private string[] GetActionMsg(string action, string DisplayToken)
    {
      switch (action)
      {
        case "address":
          return new string[2] { "ADD NEW ADDRESS?", "Add a public address to your profile." };
        case "signin":
          return new string[2] { "Sign-in to this request?", "Value should match what's in your browser." };
        case "txn":
          return new string[2] { "SIGN TRANSACTION?", "Sign then transmit a payment transaction." };
        case "image":
          return new string[2] { "REBUILD XMR BALNCE?", "Calculate Monero image keys for rebuilding balance." };
        case "gas":
          return new string[2] { "CLAIM GAS?", "Used by NEO as fuel for sending assets." };
        case "message":
          return new string[2] { "SIGN MESSAGE?", "Create signature to prove ownership of a public address." };
        case "register2fa":
          return new string[2] { "REGISTER NEW 2FA?", "" };
        case "authorize2fa":
          return new string[2] { "AUTHORIZE 2FA REQUEST?", "" };
      }

      return null;
    }

    private void BalClick()
    {
      if (!HasWindowFocus) return;

      AlertDialog.Builder wfbuilder = new AlertDialog.Builder(this)
     .SetTitle("").SetMessage("There's no wifi connection.").SetCancelable(true).SetPositiveButton("OK", (EventHandler<DialogClickEventArgs>)null);

      var wfalert = wfbuilder.Create();

      try
      {
        if (!NoxMainActivity.wsrunning())
        {
          wfalert.Show();
          TextView msgTxt = (TextView)wfalert.FindViewById(Android.Resource.Id.Message);
          msgTxt.TextSize = 18;
          msgTxt.SetTypeface(null, TypefaceStyle.Bold);
          var wfokBtn = wfalert.GetButton((int)DialogButtonType.Positive);

          wfokBtn.Click += (asender, args) =>
          {
            wfalert.Dismiss();

          };
        }
        else
        {
          if (rescl) return;
          rescl = true;
          StartSAct("overview", "");
        }
      }
      catch { }
    }

    private void AdrClick()
    {

      if (!HasWindowFocus) return;

      AlertDialog.Builder wfbuilder = new AlertDialog.Builder(this).SetTitle("").SetMessage("There's no wifi connection.").SetCancelable(true).SetPositiveButton("OK", (EventHandler<DialogClickEventArgs>)null);
      var wfalert = wfbuilder.Create();

      try
      {
        if (!NoxMainActivity.wsrunning())
        {
          wfalert.Show();
          TextView msgTxt = (TextView)wfalert.FindViewById(Android.Resource.Id.Message);
          msgTxt.TextSize = 18;
          msgTxt.SetTypeface(null, TypefaceStyle.Bold);
          var wfokBtn = wfalert.GetButton((int)DialogButtonType.Positive);

          wfokBtn.Click += (asender, args) =>
          {
            wfalert.Dismiss();

          };
        }
        else
        {
          if (rescl) return;
          rescl = true;
          StartSAct("accounts", "");
        }
      }
      catch { }
    }


    const string PREF_KEY_SHOWN = "PREF_KEY_SHOWN12";
    const string PREF_ALERT_MSG = "The world's only communication tool that isn't tied to an identity and where encryption keys are established solely between you and your peers, uniquely assisted by a blockchain contract to eliminate involvement of intermediate servers during handshake and possibility of a middleman backdoor. This device will adhere to strict memory management policies when displaying messages to ensure nothing can be retrieved, approached with extensive consideration to enforce the same methods applied when disposing of your secret information. Tap below to start a channel even more private than face to face.";
    private void MsgClick()
    {

      if (!HasWindowFocus) return;

      AlertDialog.Builder wfbuilder = new AlertDialog.Builder(this).SetTitle("").SetMessage("There's no wifi connection.").SetCancelable(true).SetPositiveButton("OK", (EventHandler<DialogClickEventArgs>)null);
      var wfalert = wfbuilder.Create();

      try
      {
        if (!NoxMainActivity.wsrunning())
        {
          wfalert.Show();
          TextView msgTxt = (TextView)wfalert.FindViewById(Android.Resource.Id.Message);
          msgTxt.TextSize = 18;
          msgTxt.SetTypeface(null, TypefaceStyle.Bold);
          var wfokBtn = wfalert.GetButton((int)DialogButtonType.Positive);

          wfokBtn.Click += (asender, args) =>
          {
            wfalert.Dismiss();

          };
        }
        else
        {

          if (!IsPrefAlertShown())
          {

            NoxMainActivity.Stop();
  
            ShowPrivMsgAlert();
           
            return;
          }

          StartPrivMsgs();
        }
      }
      catch { }

    }

    bool IsPrefAlertShown()
    {
      ISharedPreferences sharedPref = PreferenceManager.GetDefaultSharedPreferences(this.ApplicationContext);
      return sharedPref.GetBoolean(PREF_KEY_SHOWN, false);
    }
    public void UpdatePrefAlertShown()
    {
      Task.Run(() =>
      {
        ISharedPreferences sharedPref = PreferenceManager.GetDefaultSharedPreferences(this.ApplicationContext);
        var esharedPrefe = sharedPref.Edit();
        esharedPrefe.PutBoolean(PREF_KEY_SHOWN, true);
        esharedPrefe.Commit();

      });

    }

    private void ShowPrivMsgAlert()
    {
      AlertDialog.Builder wfbuilder = new AlertDialog.Builder(this, Resource.Style.MyAlertDialogThemeNox2).SetMessage(PREF_ALERT_MSG).SetTitle("BITFI PRIVATE MESSAGING").SetCancelable(false)
        .SetNegativeButton("LATER", (EventHandler<DialogClickEventArgs>)null)
     .SetPositiveButton("OK, START   ", (EventHandler<DialogClickEventArgs>)null);
      var wfShowPrivMsgAlert = wfbuilder.Create();

      try
      {
        wfShowPrivMsgAlert.Show();

        var wfokBtn = wfShowPrivMsgAlert.GetButton((int)DialogButtonType.Positive);
        var wfnokBtn = wfShowPrivMsgAlert.GetButton((int)DialogButtonType.Negative);

        TextView msgTxt = (TextView)wfShowPrivMsgAlert.FindViewById(Android.Resource.Id.Message);
        msgTxt.TextSize = 17.9f;
        msgTxt.SetTextColor(new Color(wfokBtn.CurrentTextColor));
        msgTxt.SetLineSpacing(0, 1.12f);
        msgTxt.JustificationMode = Android.Text.JustificationMode.InterWord;
        msgTxt.SetPadding(msgTxt.PaddingLeft, msgTxt.PaddingTop - 10, msgTxt.PaddingRight, 0);
        msgTxt.SetTypeface(Typeface.Default, TypefaceStyle.Normal);

      
        wfokBtn.Click += (asender, args) =>
        {
          UpdatePrefAlertShown();
          StartPrivMsgs(false);
        };

       
        wfnokBtn.Click += (asender, args) =>
        {
          Finish();
          OverridePendingTransition(0, 0);
        };
      }
      catch { }
    }
    private void StartPrivMsgs(bool noani = false)
    {
      try
      {
        if (rescl) return;
        rescl = true;

        keep = false;
        var nxact = new Intent(this, typeof(SecretActivity));
        nxact.PutExtra("action", "session_start");
        nxact.PutExtra("task", "");
        if (noani)
        {
          nxact.AddFlags(ActivityFlags.NoAnimation);
        }
        StartActivity(nxact);

      }
      catch { }

    }

    private void WifiClick()
    {
      if (rescl) return;
      rescl = true;
      keep = true;
      var nxact = new Intent(this, typeof(NoxWifi));
      StartActivity(nxact);
    }

    private void WalletIDClick()
    {

      try
      {
        if (rescl) return;
        rescl = true;

        keep = true;
        var nxact = new Intent(this, typeof(NoxViewModel));
        nxact.PutExtra("action", "noxnews");
        nxact.PutExtra("task", "");

        nxact.AddFlags(ActivityFlags.NoAnimation);
        StartActivity(nxact);

      }
      catch { }

    }

    private void LoadClickViews()
    {
      try
      {

        var xwid = FindViewById<LinearLayout>(Resource.Id.xbtnWalletID);
        var bwid = FindViewById<Button>(Resource.Id.btnWalletID);

        xwid.Click += delegate { WalletIDClick(); }; bwid.Click += delegate { WalletIDClick(); };



        var xbtnWifi = FindViewById<LinearLayout>(Resource.Id.xbtnWifi); var xbtnAddresses = FindViewById<LinearLayout>(Resource.Id.xbtnAddresses);

        var xbtnBalances = FindViewById<LinearLayout>(Resource.Id.xbtnBalances); var xbtnMessage = FindViewById<LinearLayout>(Resource.Id.xbtnMessage);

        var btnWifi = FindViewById<Button>(Resource.Id.btnWifi); var btnAddresses = FindViewById<Button>(Resource.Id.btnAddresses);

        var btnBalances = FindViewById<Button>(Resource.Id.btnBalances); var btnMessage = FindViewById<Button>(Resource.Id.btnMessage);


        xbtnWifi.Click += delegate { WifiClick(); }; xbtnBalances.Click += delegate { BalClick(); }; xbtnAddresses.Click += delegate { AdrClick(); }; xbtnMessage.Click += delegate { MsgClick(); };

        btnWifi.Click += delegate { WifiClick(); }; btnBalances.Click += delegate { BalClick(); }; btnAddresses.Click += delegate { AdrClick(); }; btnMessage.Click += delegate { MsgClick(); };

      }
      catch { }
    }

  }
}


