﻿using System;
using Android.App;
using Android.Content;
using Android.Widget;
using Android.OS;
using System.ComponentModel;
using System.Threading;
using Android.Graphics;
using Android.Views;
using System.Threading.Tasks;
using NoxService.NWS;
using NoxKeys;
using Android.Runtime;
using Android.Content.Res;
using WalletLibrary;
using Android.Net.Wifi;
using Android.Net;

namespace BitfiWallet
{
  static class NoxMainActivity
  {
    static Activity _activity;
    public static bool wsrunning()
    {
      return NoxT.WsRunning;
    }

    static NoxTManager NoxT;
    public static void Start()
    {
      NoxT.Resume(_activity);
    }
    public static void AddTime(double time_seconds = 30)
    {
      NoxT.Addtime(time_seconds);
    }
    public static void Stop()
    {
      NoxT.Pause();
    }
    private static void GetAExt()
    {
      if (NoxT == null)
      {
        try
        {
          var bund = _activity.Intent?.Extras;
          var DeviceKey = bund.GetString("token"); var DeviceID = bund.GetString("aprefuser", "");

          Device noxDevice = new Device(DeviceKey, DeviceID); NoxT = new NoxTManager(noxDevice);

          TFView.typeface = Typeface.CreateFromAsset(_activity.Assets, "Rubik-Regular.ttf"); TFView.typefaceI = Typeface.CreateFromAsset(_activity.Assets, "Rubik-Italic.ttf");
          TFView.typefaceB = Typeface.CreateFromAsset(_activity.Assets, "Rubik-Bold.ttf");
        }
        catch (Exception) { }
      }
    }
    public static Activity Value
    {
      get
      {
        return _activity;
      }
      set
      {
        _activity = value;
        GetAExt();
      }
    }
    public static BatStatus GetBatVal()
    {

      try
      {
        using (BatteryManager bm = (BatteryManager)_activity.ApplicationContext.GetSystemService("batterymanager"))
        {
          if (bm != null)
          {
            int BatLevel = bm.GetIntProperty(4);
            using (IntentFilter ifilter = new IntentFilter(Intent.ActionBatteryChanged))
            {
              using (Intent batteryStatus = _activity.ApplicationContext.RegisterReceiver(null, ifilter))
              {
                int status = batteryStatus.GetIntExtra(BatteryManager.ExtraPlugged, -1);

                bool BatCharging;

                if (status > 0 || bm.IsCharging)
                {
                  BatCharging = true;
                }
                else
                {
                  BatCharging = false;
                }

                return new BatStatus() { IsCharging = BatCharging, Level = BatLevel, IsError = false };
              }
            }
          }
        }
      }
      catch { }

      return new BatStatus() { IsError = true };
    }
    public static void LoadVTypes()
    {
      try
      {
        var w1 = _activity.FindViewById<ImageView>(Resource.Id.imageViewW1); var w2 = _activity.FindViewById<ImageView>(Resource.Id.imageViewW2);

        TextView tbbWifi = _activity.FindViewById<TextView>(Resource.Id.txtNoWifi); Button btnWifi = _activity.FindViewById<Button>(Resource.Id.btnWifi);

        var btnAddresses = _activity.FindViewById<Button>(Resource.Id.btnAddresses); var btnBalances = _activity.FindViewById<Button>(Resource.Id.btnBalances);
        var btnMessage = _activity.FindViewById<Button>(Resource.Id.btnMessage);

        w1.Visibility = ViewStates.Visible; w2.Visibility = ViewStates.Gone; btnWifi.Typeface = TFView.typeface;
        btnAddresses.Typeface = TFView.typeface; btnBalances.Typeface = TFView.typeface; btnMessage.Typeface = TFView.typeface;

        Button tvWalletID = _activity.FindViewById<Button>(Resource.Id.btnWalletID);

        tvWalletID.Text = NoxTManager.noxDevice.GetWalletID().ToUpper(); tvWalletID.Typeface = TFView.typeface;

      }
      catch { }
    }
    public static void LoadBatStatus(BatStatus batStatus)
    {
      try
      {
        if (batStatus.IsError) return;

        TextView tbbStatus = _activity.FindViewById<TextView>(Resource.Id.txtBPercent);
        var b1 = _activity.FindViewById<ImageView>(Resource.Id.imageViewB1); var b2 = _activity.FindViewById<ImageView>(Resource.Id.imageViewB2);
        b1.Visibility = ViewStates.Visible; b2.Visibility = ViewStates.Gone; tbbStatus.Text = "";

        bool battercharging = batStatus.IsCharging; int batLevel = batStatus.Level;
        bool batterylow = false;

        if (batLevel < 16) batterylow = true;

        tbbStatus.Text = batLevel + "%";

        if (battercharging)
        {
          b1.Visibility = ViewStates.Gone; b2.Visibility = ViewStates.Visible;
        }
        else
        {
          b1.Visibility = ViewStates.Visible; b2.Visibility = ViewStates.Gone;
        }
      }
      catch { }
    }
 
  }
  public class BatStatus
  {
    public bool IsCharging { get; set; }
    public Int32 Level { get; set; }
    public bool IsError { get; set; }

  }
  public class NetStatus
  {
    public string ConnectionStatus { get; set; }
    public bool NoWifi { get; set; }

  }
  public class TFView
  {
    public static Typeface typeface;
    public static Typeface typefaceI;
    public static Typeface typefaceB;
  }
}