﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WalletLibrary.Core.Abstract;

namespace NoxKeys
{

  public class TokenResponse
  {
    public int Decimals { get; set; }
    public decimal Rate { get; set; }
  }
  public class BCUnspent
  {
    public string Amount { get; set; }
    public string TxHash { get; set; }
    public int OutputN { get; set; }
    public string Address { get; set; }
  }
  public class AdrCollection
  {
    public string BTC { get; set; }
    public string LTC { get; set; }
    public string[] XMR { get; set; }
    public string ETH { get; set; }
    public string NEO { get; set; }
  }
  public class SignTransferResponse
  {
    public string ToAddress { get; set; }
    public string LineID { get; set; }
    public string Blk { get; set; }
    public string BlkDisplayName { get; set; }
    public string Amount { get; set; }
    public string AmountUSD { get; set; }
    public PaymentRequestResponse paymentRequestResponse { get; set; }

  }
  public struct XMRTaskTransferResponse
  {
    public string TxnHex { get; set; }
    public string[] SpendKeyImages { get; set; }
  }
  public struct XMRTaskImageResponse
  {
    public string WalletAddress { get; set; }
    public string[] SpendKeyImages { get; set; }
  }
  public struct RipTaskTransferResponse
  {
    public string TxnHex { get; set; }
  }
  public struct MsgTaskTransferResponse
  {
    public string MsgSig { get; set; }
  }
  public struct ApolloTaskTransferResponse
  {
    public string TxnHex { get; set; }
  }
  public struct NEOTaskTransferResponse
  {
    public string TxnHex { get; set; }
  }
  public struct ETHTaskTransferResponse
  {
    public string TxnHex { get; set; }
  }
  public struct AltoCoinTaskTransferResponse
  {
    public string FeeAmount { get; set; }

    public string FeeWarning { get; set; }
    public string TxnHex { get; set; }
  }
  public struct NEONeoscanUnspent
  {
    public string txid { get; set; }
    public decimal value { get; set; }
    public int n { get; set; }
  }
  public class NEONeoscanUnclaimed
  {
    public NEONeoscanClaimable[] claimable { get; set; }
  }

  public struct NEONeoscanClaimable
  {
    public string txid { get; set; }
    public decimal unclaimed { get; set; }
    public int n { get; set; }

  }
}