﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security;
using System.Text;
using EthereumLibrary.Hex.HexConvertors.Extensions;
using NBitcoin;
using Org.BouncyCastle.Math;

namespace NoxKeys
{
    internal class Sclear
    {
        static List<byte> NoxpszBase58 = new List<byte>();  

        internal static void NoxWriteArray(byte[] array)
        {
            if (array == null) return;
            int WriteInt = 0;

            for (int i = 0; i < array.Length; i++)
            {
                array[i] = (byte)WriteInt;
                if (WriteInt == 0)
                {
                    WriteInt = 1;
                }
                else
                {
                    WriteInt = 0;
                }
            }
        }


        internal static List<byte> EncodeB58NoxHash(byte[] data, int offset, int count)
        {
            BigInteger bn58 = BigInteger.ValueOf(58);
            BigInteger bn0 = BigInteger.Zero;

            var vchTmp = data.SafeSubarray(offset, count);
            var bn = new BigInteger(1, vchTmp);
            List<byte> builder = new List<byte>();

            while (bn.CompareTo(bn0) > 0)
            {
                var r = bn.DivideAndRemainder(bn58);
                var dv = r[0];
                BigInteger rem = r[1];
                bn = dv;
                var c = rem.IntValue;
                builder.Add(NoxpszBase58[c]);
            }

            for (int i = offset; i < offset + count && data[i] == 0; i++)
            {
                builder.Add(NoxpszBase58[0]);
            }

            builder.Reverse();
            return builder;
        }

        //"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";




        internal static bool DevTestMode = false;
        internal const bool UseXMRNative = false;
        internal const string xmrNativeName = "libbitfi_entry_x86_Debug.so";

        internal static string ThisVName = "v113";
        internal static bool BatCharging = false;
        internal static int BatLevel = 0;
        internal static bool SendExpMsg = false;
        internal static BitcoinSecret noxPrivateKey;
        internal static string pubkey;
        internal static string SaHash;
        internal static BitcoinPubKeyAddress saddress;
        internal static string PREFUSER;
        internal static Guid PREFUSER_GUID;
        internal static string WALLETID;
        internal static int MsgCount;
        internal static bool BBCreated = false;
        // public static Typeface typeface { get; set; }
        // public static Typeface typefaceI { get; set; }

        internal static int GetCurrencyIndex(string currencySymbol)
        {

            string currencyIndexString = "";
            foreach (char c in currencySymbol)
            {
                currencyIndexString = currencyIndexString + (char.ToUpper(c) - 64).ToString();
            }
            return Convert.ToInt32(currencyIndexString);
        }


        public static Network GetBLKNetworkAlt(string blk)
        {
            Network net = null;

            switch (blk)
            {
                case "btc":
                    net = Network.Main;
                    break;

                case "ltc":
                    net = NBitcoin.Altcoins.Litecoin.Instance.Mainnet;
                    break;

                case "grs":
                    net = NBitcoin.Altcoins.Groestlcoin.Instance.Mainnet;
                    break;

                case "ftc":
                    net = NBitcoin.Altcoins.Feathercoin.Instance.Mainnet;
                    break;

                case "via":
                    net = NBitcoin.Altcoins.Viacoin.Instance.Mainnet;
                    break;

                case "doge":
                    net = NBitcoin.Altcoins.Dogecoin.Instance.Mainnet; //no seg
                    break;

                case "btg":
                    net = NBitcoin.Altcoins.BGold.Instance.Mainnet;
                    break;

                case "mona":
                    net = NBitcoin.Altcoins.Monacoin.Instance.Mainnet;
                    break;

                case "dash":
                    net = NBitcoin.Altcoins.Dash.Instance.Mainnet; //no seg
                    break;

                case "zcl":
                    net = NBitcoin.Altcoins.Zclassic.Instance.Mainnet; //no seg
                    break;

                case "strat":
                    net = NBitcoin.Altcoins.Stratis.Instance.Mainnet;
                    break;

                case "dgb":
                    net = NBitcoin.Altcoins.DigiByte.Instance.Mainnet;
                    break;
            }


            return net;
        }


    }

   
}